/*******************************************************************************

	Project        : PCI express

	Component      : PCI express Driver lib

	Module         : pcielib.h

	Function       : interface header

-------------------------------------------------------------------------------
	[history]
	09-27-2010	Ver 1.00   M.Meguro    create
	07-30-2015	Ver 1.03   M.Meguro    common use of Pcie_IsDMADone function

******************************************************************************/
#ifndef		_PCIELIB_H_
#define		_PCIELIB_H_
//*******************************************/
//*    include								*/
//*******************************************/
#include	<windows.h>
#include	<stdio.h>
//*******************************************/
//*    define								*/
//*******************************************/
//֐߂l
#define		PCIE_NORMAL			(0)		//I
#define		PCIE_ERR_PARAM		(-100)	//p[^G[
#define		PCIE_ERR_REG_WRITE	(-101)	//WX^CgG[
#define		PCIE_ERR_REG_READ	(-102)	//WX^[hG[
#define		PCIE_ERR_BLK_WRITE	(-103)	//ubNCgG[
#define		PCIE_ERR_BLK_READ	(-104)	//ubN[hG[
#define		PCIE_ERR_REG_INTR	(-105)	//荞ݓo^G[
#define		PCIE_ERR_UNREG_INTR	(-106)	//荞ݓo^G[
#define		PCIE_ERR_GET_DMA	(-107)	//DMA擾G[
#define		PCIE_ERR_REL_DMA	(-108)	//DMAJG[
#define		PCIE_ERR_WRITE_CFG	(-109)	//PCI configCgG[
#define		PCIE_ERR_READ_CFG	(-110)	//PCI config[hG[
#define		PCIE_ERR_DMA_DONE	(-111)	//dma done error
//*******************************************/
//*    function								*/
//*******************************************/
#ifdef __cplusplus
extern "C" {
#endif

extern	void
Pcie_SetDeviceAndEventName(
	BYTE		*lpszDeviceName,
	BYTE		*lpszEventName
);
extern	HANDLE
Pcie_OpenDevice(
	int			nDevNum
);
extern	void
Pcie_CloseDevice(
	HANDLE		hDev
);
extern	int
Pcie_WriteRegister32(
	HANDLE		hDev,
	DWORD		bar,
	DWORD		offset,
	DWORD		value
);
extern	int
Pcie_WriteRegister16(
	HANDLE		hDev,
	DWORD		bar,
	DWORD		offset,
	WORD		value
);
extern	int
Pcie_WriteRegister8(
	HANDLE		hDev,
	DWORD		bar,
	DWORD		offset,
	BYTE		value
);
extern	int
Pcie_ReadRegister32(
	HANDLE		hDev,
	DWORD		bar,
	DWORD		offset,
	DWORD		*pvalue
);
extern	int
Pcie_ReadRegister16(
	HANDLE		hDev,
	DWORD		bar,
	DWORD		offset,
	WORD		*pvalue
);
extern	int
Pcie_ReadRegister8(
	HANDLE		hDev,
	DWORD		bar,
	DWORD		offset,
	BYTE		*pvalue
);
extern	int
Pcie_WriteBlock(
	HANDLE		hDev,
	DWORD		bar,
	DWORD		offset,
	DWORD		size,
	void		*buffer
);
extern	int
Pcie_ReadBlock(
	HANDLE		hDev,
	DWORD		bar,
	DWORD		offset,
	DWORD		size,
	void		*buffer
);
extern	int
Pcie_RegisterIntr(
	HANDLE		hDev,
	DWORD		ctrlbase,
	DWORD		ctrloffset,
	DWORD		ctrltype,
	DWORD		maskvalue,
	DWORD		statusbase,
	DWORD		statusoffset,
	DWORD		statustype,
	DWORD		intrvalue,
	HANDLE		*phEvent
);
extern	int
Pcie_UnRegisterIntr(
	HANDLE		hDev,
	HANDLE		hEvent
);
extern	int
Pcie_GetDMAMem(
	HANDLE		hDev,
	DWORD		size,
	void		**phy,
	void		**usr
);
extern	int
Pcie_RelDMAMem(
	HANDLE		hDev
);
extern	int
Pcie_WritePciConfig(
	HANDLE		hDev,
	DWORD		size,
	DWORD		offset,
	void		*buffer
);
extern	int
Pcie_ReadPciConfig(
	HANDLE		hDev,
	DWORD		size,
	DWORD		offset,
	void		*buffer
);
extern	int
Pcie_IsDMADone(
	HANDLE	hDev,
	HANDLE	hEvent,
	DWORD	timeout
);

#ifdef __cplusplus
}
#endif

#endif
