/*******************************************************************************

	Project        : PCI express

	Component      : sample app

	Module         : blockwrite.c

	Function       : block write sample

-------------------------------------------------------------------------------
	[history]
	09-27-2010	Ver 1.00   M.Meguro    create
	07-09-2015	Ver	1.03   Y.Watanabe  device number is input by a command line argument

******************************************************************************/
//*******************************************/
//*    include								*/
//*******************************************/
#include	<stdlib.h>
#include	"pcielib.h"

int
main(
	int		argc,
	char	*argv[]
)
{
	HANDLE	hDevice;
	int		ret;
	int		devnum;
	char	*stopstring;
	DWORD	bar;
	DWORD	offset;
	DWORD	size;
	BYTE	*buffer;
	FILE	*fp;

	if(argc!=6)
	{
		printf("Usage:\n");
		printf("\tblockwrite [device number] [address space] [offset] [size] [file]\n");
		printf("\tdevice number:device number functions\n");
		printf("\taddress space:base address number\n");
		printf("\toffset:register offset\n");
		printf("\tsize:write bytes\n");
		printf("\tfile:send file name\n");
		exit(0);
	}
	devnum=strtol(argv[1],&stopstring,0);
	hDevice=Pcie_OpenDevice(devnum);
	if(hDevice!=INVALID_HANDLE_VALUE)
	{
		bar=strtol(argv[2],&stopstring,0);
		offset=strtol(argv[3],&stopstring,0);
		size=strtol(argv[4],&stopstring,0);
		buffer=malloc(size);
		if(buffer)
		{
			fp=fopen(argv[5],"rb");
			if(fp)
			{
				fread(buffer,1,size,fp);
				fclose(fp);
				ret=Pcie_WriteBlock(hDevice,bar,offset,size,buffer);
				if(ret!=PCIE_NORMAL)
					printf("Pcie_WriteBlock error=%d\n",ret);
			}
			free(buffer);
		}
	}
	else
		printf("driver open error\n");
	if(hDevice!=INVALID_HANDLE_VALUE)
		Pcie_CloseDevice(hDevice);
	return(0);
}
