/*******************************************************************************

	Project        : PCI express

	Component      : sample app

	Module         : writepciconf.c

	Function       : write pci config

-------------------------------------------------------------------------------
	[history]
	09-27-2010	Ver 1.00   M.Meguro    create
	07-09-2015	Ver	1.03   Y.Watanabe  device number is input by a command line argument

******************************************************************************/
//*******************************************/
//*    include								*/
//*******************************************/
#include	"pcielib.h"

int
main(
	int		argc,
	char	*argv[]
)
{
	HANDLE	hDevice;
	int		ret;
	int		devnum;
	char	*stopstring;
	DWORD	size;
	DWORD	offset;
	DWORD	value;

	if(argc!=5)
	{
		printf("Usage:\n");
		printf("\twritepciconf [device number] [size] [offset] [value]\n");
		printf("\tdevice number:device number functions\n");
		printf("\tsize:write size[MAX 4BYTE]\n");
		printf("\toffset:configuration area offset\n");
		printf("\tvalue:write value\n");
		exit(0);
	}
	devnum=strtol(argv[1],&stopstring,0);
	hDevice=Pcie_OpenDevice(devnum);
	if(hDevice!=INVALID_HANDLE_VALUE)
	{
		size=strtol(argv[2],&stopstring,0);
		if(size>4)
		{
			printf("size is 4byte over\n");
			goto EXIT;
		}
		offset=strtol(argv[3],&stopstring,0);
		value=strtol(argv[4],&stopstring,0);
		ret=Pcie_WritePciConfig(hDevice,size,offset,&value);
		if(ret!=PCIE_NORMAL)
			printf("Pcie_WritePciConfig error=%d\n",ret);
	}
	else
		printf("driver open error\n");
EXIT:
	if(hDevice!=INVALID_HANDLE_VALUE)
		Pcie_CloseDevice(hDevice);
}
